---
title: Implement External Form Navigation
product: Form Library
description: Learn how to enhance your form navigation with external controls that dynamically update the form page number in real-time. Implement external buttons for seamless form progression. Unlock the power of controlling your form from outside the form widget and create a streamlined user experience. Free demo for JavaScript.
framework: Vanilla JS
source: https://surveyjs.io/form-library/examples/external-form-navigation-system/vanillajs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Implement External Form Navigation (Vanilla JS)

SurveyJS ships with multiple navigation features that you can add to your forms: navigation buttons, a [table of contents](https://surveyjs.io/form-library/examples/table-of-contents/), and various types of [progress indicators](https://surveyjs.io/form-library/examples/configure-form-navigation-with-progress-indicators/). You can also implement custom navigation elements that extend the built-in functionality or completely replace it. This demo shows how to implement external form navigation controls&mdash;a page selector, navigation buttons, and a progress indicator&mdash;and use them in conjunction with built-in form navigation features.

## Configure a Page Selector

A page selector is a UI element that displays a list of survey pages and enables users to jump to a selected page. Usually, a page selector is a drop-down menu. If your survey contains a few pages only, a page selector can be a set of buttons with page numbers.

This example demonstrates a drop-down page selector built upon a standard `<select>` HTML element. To fill `<select>` options, iterate over `SurveyModel`'s [`visiblePages`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#visiblePages) array and create an `<option>` element for each array item. Within the `<select>` element's `onchange` event handler, call the current page's [`validate()`](https://surveyjs.io/form-library/documentation/api-reference/page-model#validate) method to perform validation. If all answers on the current page are valid, assign the selected page number to `SurveyModel`'s [`currentPageNo`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#currentPageNo) property. Note that this property starts to enumerate survey pages with 0.

## Implement Navigation Buttons

Built-in survey navigation buttons include Start, Next Page, Previous Page, Preview, and Complete. Depending on your use case, you may need to implement all the buttons or only a part of them. This demo implements the Next Page, Previous Page, and Complete buttons.

Add `<button>` elements to your page. To navigate between survey pages, call `SurveyModel`'s [`nextPage()`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#nextPage) and [`prevPage()`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#prevPage) methods within `<button>`'s `onclick` event handler. To end the survey, call the [`tryComplete()`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#tryComplete) method.

Navigation button visibility may depend on the current page. For example, the Previous Page button should not be visible on the first survey page, or the Complete button should appear only when a user has reached the last page. To control button visibility, use `SurveyModel`'s [`isFirstPage`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#isFirstPage) and [`isLastPage`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#isLastPage) properties or compare the `currentPageNo` property value with the length of the [`visiblePages`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#visiblePages) array.

If you implement custom navigation buttons, you may want to hide the built-in buttons to avoid functionality duplication. To do this, disable the [`showNavigationButtons`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#showNavigationButtons) property. This demo, however, keeps the built-in buttons visible to show how they can work alongside custom buttons.

## Add a Progress Indicator

A progress indicator helps users understand how far along the survey they have advanced. Progress indicators can show the number of completed survey pages, answered questions, or other progress information. In this demo, a progress indicator displays the current page number and the total number of survey pages. Use `SurveyModel`'s [`currentPageNo`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#currentPageNo) property and the length of the [`visiblePages`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#visiblePages) array to implement this progress indicator. Note that `currentPageNo` starts to enumerate survey pages with 0. Therefore, you need to add 1 to its value to get the actual current page number.

## Handle Navigation Events

A survey raises the following events that may be useful when you implement an external navigation system:

- [`onStarted`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onStarted)\
Raised when the survey starts.
- [`onCurrentPageChanged`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onCurrentPageChanged)\
Raised after the current page is switched.
- [`onComplete`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onComplete)\
Raised after the survey is completed.

## Files

### `public/index.html`

```html
<div id="surveyExternalNavigation">
    <div class="navigation-block">
        <select id="pageSelector" aria-label="Select survey page" class="navigation-page-selector" onchange="jumpToPage(event)"></select>

        <div class="navigation-progress-container">
            <div class="navigation-buttons-container">
                <div class="navigation-text-container">
                    <span class="navigation-text" id="surveyProgress"></span>
                </div>
                <button id="surveyPrev" class="navigation-button" onclick="survey.prevPage();">Previous Page</button>
                <button id="surveyNext" class="navigation-button" onclick="survey.nextPage();">Next Page</button>
                <button id="surveyComplete" class="navigation-button" onclick="survey.tryComplete();">Complete</button>
            </div>            
        </div>
    </div>
</div>
<div id="surveyElement"></div>
```

### `src/index.css`

```css
.navigation-block {
    display: flex;
    padding: 24px;
    align-items: center;
    gap: 16px;
    justify-content: space-between;
    background-color: #fff;
}

.navigation-page-selector {
    box-sizing: border-box;
    width: 100%;
    flex-basis: 240px;
    cursor: pointer;
    background-color: var(--sjs2-color-component-formbox-default-bg, #f5f5f5);
    border: none;
    border-radius: var(--sjs2-radius-component-formbox, 8px);
    box-shadow: var(
        --sjs2-border-effect-component-formbox-default,
        0 1px 2px 0 #d4d4d4 inset
    );
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
    font-family: var(--sjs2-typography-font-family-component-input-content, inherit);
    font-size: var(--sjs2-typography-font-size-component-input-content, 16px);
    font-weight: var(--sjs2-typography-font-weight-component-input-content, 400);
    line-height: var(--sjs2-typography-line-height-component-input-content, 24px);
    color: var(--sjs2-color-component-input-default-value, #1c1b20);
    min-height: calc(
        var(--sjs2-typography-line-height-component-input-content, 24px) +
            var(--sjs2-spacing-x100, 8px) * 2 +
            var(--sjs2-spacing-x050, 4px) * 2
    );
    padding:
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x100, 8px))
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x150, 12px) + 1.25em)
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x100, 8px))
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x150, 12px));
    background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 10 10'%3E%3Cpolygon fill='%23404040' points='2,2 0,4 5,9 10,4 8,2 5,5'/%3E%3C/svg%3E");
    background-repeat: no-repeat;
    background-position: right calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x150, 12px)) center;
    background-size: 0.57em auto;
}

.navigation-page-selector:focus {
    outline: none;
    background-color: var(--sjs2-color-component-formbox-focused-bg, #f5f5f5);
    box-shadow:
        var(--sjs2-border-effect-component-formbox-default-reset, 0 0 0 0 #d4d4d4 inset),
        var(--sjs2-border-effect-component-formbox-focused, 0 0 0 2px #19b394 inset);
}
.navigation-progress-container {
    display: flex;
    flex-direction: column;
    align-items: end;
}
.navigation-buttons-container {
    display: flex;
    gap: 8px;
}
.navigation-button {
    line-height: 24px;
    font-weight: 600;
    font-family: 'Open Sans';
    font-style: normal;

    font-size: 16px;
    padding: 12px 32px;
    border-color: #000000;
    border-radius: 4px;    
    background-color: #FFFFFF;
    color: #000;
    cursor: pointer;
    outline: none;
}
.navigation-text-container {
    line-height: 24px;
    font-family: 'Open Sans';    
    padding: 12px 24px;
    color: #000;
    cursor: pointer;
    outline: none;
}
.navigation-text {
    right: 0;
    top: 8px;
    font-family: 'Open Sans';
    font-style: normal;
    font-weight: 400;
    font-size: 12px;
    line-height: 16px;
    color: #000;
    text-align: right;            
}

```

### `src/index.js`

```js
import { Model } from "survey-core";
import "survey-js-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function updateNavBar() {
    document.getElementById('surveyExternalNavigation').style.display = survey.isCompleted ? "none" : "";
    document.getElementById('pageSelector').value = survey.currentPageNo;
    document.getElementById('surveyPrev').style.display = !survey.isFirstPage ? "inline" : "none";
    document.getElementById('surveyNext').style.display = !survey.isLastPage ? "inline" : "none";
    document.getElementById('surveyComplete').style.display = survey.isLastPage ? "inline" : "none";
    document.getElementById('surveyProgress').innerText = "Page " + (survey.currentPageNo + 1) + " of " + survey.visiblePageCount;
}
function setupPageSelector() {
  const pageSelector = document.getElementById('pageSelector');
  for (let i = 0; i < survey.visiblePages.length; i++) {
    const option = document.createElement("option");
    option.value = i;
    option.text = "Page " + (i + 1);
    pageSelector.add(option);
  }
}
function jumpToPage(event) {
  const input = event.target;
  if (survey.currentPage.validate()) {
    survey.currentPageNo = JSON.parse(input.value);
  } else {
    input.value = survey.currentPageNo.toString();
  }
}
window.jumpToPage = jumpToPage;
const survey = new Model(json);
survey.onComplete.add((sender, options) => {
    console.log(JSON.stringify(sender.data, null, 3));
});
window.survey = survey;
survey.onCurrentPageChanged.add(() => {
    updateNavBar();
});
survey.onComplete.add(() => {
    updateNavBar();
});
setupPageSelector();
updateNavBar();


survey.render(document.getElementById("surveyElement"));
```

### `src/json.js`

```js
export const json = {
  "title": "Patient Assessment Form",
  "pages": [
   {
    "name": "Patient information",
    "elements": [
     {
      "type": "panel",
      "name": "patient-information",
      "elements": [
       {
        "type": "text",
        "name": "first-name",
        "title": "First name"
       },
       {
        "type": "text",
        "name": "last-name",
        "startWithNewLine": false,
        "title": "Last name"
       },
       {
        "type": "text",
        "name": "ssn",
        "title": "Social Security number",
        "requiredErrorText": "You SSN must be a 9-digit number.",
        "validators": [
         {
          "type": "regex",
          "text": "Your SSN must be a 9-digit number",
          "regex": "^(?!0{3})(?!6{3})[0-8]\\d{2}-?(?!0{2})\\d{2}-?(?!0{4})\\d{4}$"
         }
        ],
        "maxLength": 9
       },
       {
        "type": "text",
        "name": "birthdate",
        "startWithNewLine": false,
        "title": "Date of birth",
        "inputType": "date",
        "maxValueExpression": "today()"
       },
       {
        "type": "text",
        "name": "concerns",
        "title": "List any concerns you want to talk about during your visit"
       }
      ]
     }
    ],
    "title": "Patient information"
   },
   {
    "name": "Health history",
    "elements": [
     {
      "type": "panel",
      "name": "health-history",
      "elements": [
       {
        "type": "boolean",
        "name": "diabetes",
        "startWithNewLine": false,
        "title": "Do you have diabetes?"
       },
       {
        "type": "boolean",
        "name": "high-blood-pressure",
        "startWithNewLine": false,
        "title": "High blood pressure?"
       },
       {
        "type": "boolean",
        "name": "high-cholesterol",
        "startWithNewLine": false,
        "title": "High cholesterol?"
       },
       {
        "type": "comment",
        "name": "other-health-conditions",
        "title": "Do you have other health conditions?",
        "maxLength": 300
       }
      ]
     }
    ],
    "title": "Health history"
   },
   {
    "name": "Social history",
    "elements": [
     {
      "type": "panel",
      "name": "social-history",
      "elements": [
       {
        "type": "panel",
        "name": "smoking",
        "elements": [
         {
          "type": "radiogroup",
          "name": "cigarettes",
          "title": "Do you smoke cigarettes?",
          "choices": [
           {
            "value": "never",
            "text": "Never"
           },
           {
            "value": "yes",
            "text": "Yes"
           },
           {
            "value": "quit",
            "text": "Quit"
           }
          ]
         },
         {
          "type": "text",
          "name": "packs-a-day",
          "visibleIf": "{cigarettes} = 'yes'",
          "title": "How many packs a day?",
          "inputType": "number",
          "min": 0
         },
         {
          "type": "panel",
          "name": "smoking-history",
          "elements": [
           {
            "type": "text",
            "name": "date-quit",
            "title": "Date quit",
            "titleLocation": "left",
            "inputType": "date",
            "maxValueExpression": "today()"
           },
           {
            "type": "text",
            "name": "years-smoked",
            "title": "Years smoked",
            "titleLocation": "left",
            "inputType": "number",
            "min": 0
           }
          ],
          "visibleIf": "{cigarettes} = 'quit'"
         },
         {
          "type": "boolean",
          "name": "vape",
          "title": "Do you vape (e-cigarettes)?"
         }
        ]
       },
       {
        "type": "panel",
        "name": "alcohol-use-history",
        "elements": [
         {
          "type": "boolean",
          "name": "alcohol",
          "title": "Do you drink alcohol?"
         },
         {
          "type": "text",
          "name": "drinks-per-week",
          "visibleIf": "{alcohol} = true",
          "title": "How many drinks per week?"
         }
        ],
        "startWithNewLine": false
       },
       {
        "type": "panel",
        "name": "drug-use-history",
        "elements": [
         {
          "type": "checkbox",
          "name": "recreational-drugs",
          "title": "Do you use recreational drugs?",
          "choices": [
           {
            "value": "rarely",
            "text": "Rarely"
           },
           {
            "value": "marijuana",
            "text": "Marijuana"
           },
           {
            "value": "cocaine",
            "text": "Cocaine"
           },
           {
            "value": "opioids",
            "text": "Opioids"
           }
          ],
          "showOtherItem": true,
          "showNoneItem": true,
          "otherPlaceholder": "Please specify... ",
          "noneText": "Never",
          "otherText": "Other",
          "colCount": 3
         },
         {
          "type": "text",
          "name": "drug-use-times-per-month",
          "visibleIf": "{recreational-drugs} anyof ['rarely', 'marijuana', 'cocaine', 'opioids', 'other']",
          "title": "How many times per month",
          "description": "If you take different types of drugs, please specify the frequency of use for each in a 'drug - # times/month' format."
         }
        ]
       },
       {
        "type": "panel",
        "name": "personal-info",
        "elements": [
         {
          "type": "dropdown",
          "name": "education",
          "title": "What is your highest level of education completed?",
          "choices": [
           {
            "value": "high-school",
            "text": "High School"
           },
           {
            "value": "trade-school",
            "text": "Trade School"
           },
           {
            "value": "college",
            "text": "College"
           },
           {
            "value": "post-graduate",
            "text": "Post-graduate degree(s)"
           }
          ]
         },
         {
          "type": "dropdown",
          "name": "marital-status",
          "title": "What is your marital status?",
          "choices": [
           {
            "value": "married",
            "text": "Married"
           },
           {
            "value": "partnership",
            "text": "Partnership"
           },
           {
            "value": "divorced",
            "text": "Divorced"
           },
           {
            "value": "separated",
            "text": "Separated"
           },
           {
            "value": "single",
            "text": "Single"
           },
           {
            "value": "widow",
            "text": "Widow(er)"
           }
          ]
         },
         {
          "type": "panel",
          "name": "sexual-life",
          "elements": [
           {
            "type": "boolean",
            "name": "sexually-active",
            "title": "Are you sexually active?"
           },
           {
            "type": "text",
            "name": "sexual-partners-number",
            "title": "How many sexual partners do you have?",
            "inputType": "number",
            "min": 0
           },
           {
            "type": "radiogroup",
            "name": "sexual-partners-gender",
            "titleLocation": "hidden",
            "choices": [
             {
              "value": "men",
              "text": "Men"
             },
             {
              "value": "women",
              "text": "Women"
             },
             {
              "value": "both",
              "text": "Both"
             }
            ],
            "colCount": 3
           },
           {
            "type": "radiogroup",
            "name": "contraception",
            "title": "Do you use contraception?",
            "showCommentArea": true,
            "commentText": "If yes, what method?",
            "choices": [
             {
              "value": "yes",
              "text": "Yes"
             },
             {
              "value": "no",
              "text": "No"
             }
            ]
           }
          ]
         }
        ]
       },
       {
        "type": "panel",
        "name": "employment-exercises-children",
        "elements": [
         {
          "type": "radiogroup",
          "name": "employment",
          "title": "Are you employed?",
          "showCommentArea": true,
          "commentText": "Type of work",
          "choices": [
           {
            "value": "yes",
            "text": "Yes"
           },
           {
            "value": "no",
            "text": "No"
           },
           {
            "value": "retired",
            "text": "Retired"
           }
          ],
          "colCount": 3
         },
         {
          "type": "panel",
          "name": "physical-activity",
          "elements": [
           {
            "type": "radiogroup",
            "name": "do-exercise",
            "title": "Do you exercise?",
            "choices": [
             {
              "value": "yes",
              "text": "Yes"
             },
             {
              "value": "no",
              "text": "No"
             }
            ],
            "colCount": 2
           },
           {
            "type": "multipletext",
            "name": "activities",
            "visibleIf": "{do-exercise} = 'yes'",
            "titleLocation": "hidden",
            "items": [
             {
              "name": "activity-type",
              "title": "Type of activity"
             },
             {
              "name": "activity-frequency",
              "title": "How often"
             },
             {
              "name": "activity-duration",
              "title": "How long per activity"
             }
            ]
           }
          ]
         },
         {
          "type": "panel",
          "name": "children",
          "elements": [
           {
            "type": "boolean",
            "name": "have-children",
            "title": "Do you have children?"
           },
           {
            "type": "multipletext",
            "name": "children-ages",
            "visibleIf": "{have-children} = true",
            "titleLocation": "hidden",
            "items": [
             {
              "name": "children-number",
              "title": "# of children"
             },
             {
              "name": "ages",
              "title": "Their ages"
             }
            ]
           }
          ]
         }
        ],
        "startWithNewLine": false
       }
      ]
     }
    ],
    "title": "Social history"
   },
   {
    "name": "Surgical history / recent hospitalizations",
    "elements": [
     {
      "type": "comment",
      "name": "surgery-description",
      "title": "Date and type of surgery / procedure"
     }
    ],
    "title": "Surgical history / recent hospitalizations"
   },
   {
    "name": "Family history",
    "elements": [
     {
      "type": "matrixdynamic",
      "name": "family-history",
      "titleLocation": "hidden",
      "columns": [
       {
        "name": "relation",
        "title": "Relation"
       },
       {
        "name": "health-conditions",
        "title": "Health conditions"
       },
       {
        "name": "cancer-history",
        "title": "Family history of cancer"
       }
      ],
      "cellType": "text"
     }
    ],
    "title": "Family history"
   },
   {
    "name": "Preventive care",
    "elements": [
     {
      "type": "panel",
      "name": "preventive-care",
      "elements": [
       {
        "type": "panel",
        "name": "recent-shots-panel",
        "elements": [
         {
          "type": "matrixdropdown",
          "name": "recent-shots",
          "title": "Recent shots from a doctor or pharmacist",
          "columns": [
           {
            "name": "date",
            "title": "Date"
           },
           {
            "name": "place",
            "title": "Place"
           }
          ],
          "cellType": "text",
          "rows": [
           {
            "value": "flu",
            "text": "Flu"
           },
           {
            "value": "shingles",
            "text": "Shingles"
           },
           {
            "value": "pneumonia",
            "text": "Pneumonia"
           },
           {
            "value": "tetanus",
            "text": "Tetanus"
           },
           {
            "value": "other",
            "text": "Other"
           }
          ]
         }
        ]
       },
       {
        "type": "panel",
        "name": "recent-tests-panel",
        "elements": [
         {
          "type": "matrixdropdown",
          "name": "recent-tests",
          "title": "Recent tests or procedures",
          "columns": [
           {
            "name": "date",
            "title": "Date"
           },
           {
            "name": "place",
            "title": "Place"
           }
          ],
          "cellType": "text",
          "rows": [
           {
            "value": "colonoscopy",
            "text": "Colonoscopy"
           },
           {
            "value": "cologuard",
            "text": "Cologuard"
           },
           {
            "value": "mammogram",
            "text": "Mammogram"
           },
           {
            "value": "pap",
            "text": "PAP"
           },
           {
            "value": "other",
            "text": "Other"
           }
          ]
         }
        ],
        "startWithNewLine": false
       },
       {
        "type": "panel",
        "name": "specialists-panel",
        "elements": [
         {
          "type": "matrixdynamic",
          "name": "specialists",
          "title": "Specialists",
          "columns": [
           {
            "name": "provider",
            "title": "Provider's first and last name"
           },
           {
            "name": "speciality",
            "title": "Speciality"
           },
           {
            "name": "city",
            "title": "Town/City"
           }
          ],
          "cellType": "text",
          "rowCount": 1
         }
        ]
       },
       {
        "type": "panel",
        "name": "medications-and-allergies",
        "elements": [
         {
          "type": "multipletext",
          "name": "medications",
          "title": "Medications",
          "items": [
           {
            "name": "medication-name",
            "title": "Name"
           },
           {
            "name": "medication-dose",
            "title": "Dose"
           },
           {
            "name": "medication-times-per-day",
            "title": "Times per day"
           }
          ]
         },
         {
          "type": "multipletext",
          "name": "allergies",
          "startWithNewLine": false,
          "title": "Allergies",
          "items": [
           {
            "name": "allergy-type",
            "title": "Type"
           },
           {
            "name": "allergy-reaction",
            "title": "Reaction"
           }
          ]
         }
        ]
       }
      ]
     }
    ],
    "title": "Preventive care"
   },
   {
    "name": "Symptoms",
    "elements": [
     {
      "type": "tagbox",
      "name": "symptoms",
      "title": "Please select any symptoms you have now or have had in the past month.",
      "choices": [
       "Fever",
       "Chills",
       "Feeling poorly",
       "Feeling tired",
       "Weight gain",
       "Weight loss",
       "Chest pain",
       "Heart pounding",
       "Fast pulse",
       "Slow pulse",
       "Leg pain with exercise",
       "Leg swelling",
       "Joint pain",
       "Neck pain",
       "Joint swelling",
       "Joint stiffness",
       "Muscle aches",
       "Back pain",
       "Sores",
       "Rash",
       "Itching",
       "Change in a mole",
       "Unusual growth/spot"
      ]
     },
     {
      "type": "signaturepad",
      "name": "signature",
      "title": "Signature:",
      "titleLocation": "left"
     },
     {
      "type": "text",
      "name": "current-date",
      "startWithNewLine": false,
      "title": "Today's date:",
      "titleLocation": "left",
      "defaultValueExpression": "today()",
      "inputType": "date"
     }
    ],
    "title": "Symptoms"
   }
  ]
 };
```

### `package.json`

```json
{
  "dependencies": {
    "survey-core": "latest",
    "survey-js-ui": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/external-form-navigation-system/angular.md)
- [React](https://surveyjs.io/form-library/examples/external-form-navigation-system/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/external-form-navigation-system/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/external-form-navigation-system/jquery.md)


---
title: Implement External Form Navigation
product: Form Library
description: Learn how to enhance your form navigation with external controls that dynamically update the form page number in real-time. Implement external buttons for seamless form progression. Unlock the power of controlling your form from outside the form widget and create a streamlined user experience. Free demo for JavaScript.
framework: Angular
source: https://surveyjs.io/form-library/examples/external-form-navigation-system/angular
index: https://surveyjs.io/form-library/examples/overview.md
---

# Implement External Form Navigation (Angular)

SurveyJS ships with multiple navigation features that you can add to your forms: navigation buttons, a [table of contents](https://surveyjs.io/form-library/examples/table-of-contents/), and various types of [progress indicators](https://surveyjs.io/form-library/examples/configure-form-navigation-with-progress-indicators/). You can also implement custom navigation elements that extend the built-in functionality or completely replace it. This demo shows how to implement external form navigation controls&mdash;a page selector, navigation buttons, and a progress indicator&mdash;and use them in conjunction with built-in form navigation features.

## Configure a Page Selector

A page selector is a UI element that displays a list of survey pages and enables users to jump to a selected page. Usually, a page selector is a drop-down menu. If your survey contains a few pages only, a page selector can be a set of buttons with page numbers.

This example demonstrates a drop-down page selector built upon a standard `<select>` HTML element. To fill `<select>` options, iterate over `SurveyModel`'s [`visiblePages`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#visiblePages) array and create an `<option>` element for each array item. Within the `<select>` element's `onchange` event handler, call the current page's [`validate()`](https://surveyjs.io/form-library/documentation/api-reference/page-model#validate) method to perform validation. If all answers on the current page are valid, assign the selected page number to `SurveyModel`'s [`currentPageNo`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#currentPageNo) property. Note that this property starts to enumerate survey pages with 0.

## Implement Navigation Buttons

Built-in survey navigation buttons include Start, Next Page, Previous Page, Preview, and Complete. Depending on your use case, you may need to implement all the buttons or only a part of them. This demo implements the Next Page, Previous Page, and Complete buttons.

Add `<button>` elements to your page. To navigate between survey pages, call `SurveyModel`'s [`nextPage()`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#nextPage) and [`prevPage()`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#prevPage) methods within `<button>`'s `onclick` event handler. To end the survey, call the [`tryComplete()`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#tryComplete) method.

Navigation button visibility may depend on the current page. For example, the Previous Page button should not be visible on the first survey page, or the Complete button should appear only when a user has reached the last page. To control button visibility, use `SurveyModel`'s [`isFirstPage`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#isFirstPage) and [`isLastPage`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#isLastPage) properties or compare the `currentPageNo` property value with the length of the [`visiblePages`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#visiblePages) array.

If you implement custom navigation buttons, you may want to hide the built-in buttons to avoid functionality duplication. To do this, disable the [`showNavigationButtons`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#showNavigationButtons) property. This demo, however, keeps the built-in buttons visible to show how they can work alongside custom buttons.

## Add a Progress Indicator

A progress indicator helps users understand how far along the survey they have advanced. Progress indicators can show the number of completed survey pages, answered questions, or other progress information. In this demo, a progress indicator displays the current page number and the total number of survey pages. Use `SurveyModel`'s [`currentPageNo`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#currentPageNo) property and the length of the [`visiblePages`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#visiblePages) array to implement this progress indicator. Note that `currentPageNo` starts to enumerate survey pages with 0. Therefore, you need to add 1 to its value to get the actual current page number.

## Handle Navigation Events

A survey raises the following events that may be useful when you implement an external navigation system:

- [`onStarted`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onStarted)\
Raised when the survey starts.
- [`onCurrentPageChanged`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onCurrentPageChanged)\
Raised after the current page is switched.
- [`onComplete`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onComplete)\
Raised after the survey is completed.

## Files

### `src/app/components/json.ts`

```ts
export const json = {
  "title": "Patient Assessment Form",
  "pages": [
   {
    "name": "Patient information",
    "elements": [
     {
      "type": "panel",
      "name": "patient-information",
      "elements": [
       {
        "type": "text",
        "name": "first-name",
        "title": "First name"
       },
       {
        "type": "text",
        "name": "last-name",
        "startWithNewLine": false,
        "title": "Last name"
       },
       {
        "type": "text",
        "name": "ssn",
        "title": "Social Security number",
        "requiredErrorText": "You SSN must be a 9-digit number.",
        "validators": [
         {
          "type": "regex",
          "text": "Your SSN must be a 9-digit number",
          "regex": "^(?!0{3})(?!6{3})[0-8]\\d{2}-?(?!0{2})\\d{2}-?(?!0{4})\\d{4}$"
         }
        ],
        "maxLength": 9
       },
       {
        "type": "text",
        "name": "birthdate",
        "startWithNewLine": false,
        "title": "Date of birth",
        "inputType": "date",
        "maxValueExpression": "today()"
       },
       {
        "type": "text",
        "name": "concerns",
        "title": "List any concerns you want to talk about during your visit"
       }
      ]
     }
    ],
    "title": "Patient information"
   },
   {
    "name": "Health history",
    "elements": [
     {
      "type": "panel",
      "name": "health-history",
      "elements": [
       {
        "type": "boolean",
        "name": "diabetes",
        "startWithNewLine": false,
        "title": "Do you have diabetes?"
       },
       {
        "type": "boolean",
        "name": "high-blood-pressure",
        "startWithNewLine": false,
        "title": "High blood pressure?"
       },
       {
        "type": "boolean",
        "name": "high-cholesterol",
        "startWithNewLine": false,
        "title": "High cholesterol?"
       },
       {
        "type": "comment",
        "name": "other-health-conditions",
        "title": "Do you have other health conditions?",
        "maxLength": 300
       }
      ]
     }
    ],
    "title": "Health history"
   },
   {
    "name": "Social history",
    "elements": [
     {
      "type": "panel",
      "name": "social-history",
      "elements": [
       {
        "type": "panel",
        "name": "smoking",
        "elements": [
         {
          "type": "radiogroup",
          "name": "cigarettes",
          "title": "Do you smoke cigarettes?",
          "choices": [
           {
            "value": "never",
            "text": "Never"
           },
           {
            "value": "yes",
            "text": "Yes"
           },
           {
            "value": "quit",
            "text": "Quit"
           }
          ]
         },
         {
          "type": "text",
          "name": "packs-a-day",
          "visibleIf": "{cigarettes} = 'yes'",
          "title": "How many packs a day?",
          "inputType": "number",
          "min": 0
         },
         {
          "type": "panel",
          "name": "smoking-history",
          "elements": [
           {
            "type": "text",
            "name": "date-quit",
            "title": "Date quit",
            "titleLocation": "left",
            "inputType": "date",
            "maxValueExpression": "today()"
           },
           {
            "type": "text",
            "name": "years-smoked",
            "title": "Years smoked",
            "titleLocation": "left",
            "inputType": "number",
            "min": 0
           }
          ],
          "visibleIf": "{cigarettes} = 'quit'"
         },
         {
          "type": "boolean",
          "name": "vape",
          "title": "Do you vape (e-cigarettes)?"
         }
        ]
       },
       {
        "type": "panel",
        "name": "alcohol-use-history",
        "elements": [
         {
          "type": "boolean",
          "name": "alcohol",
          "title": "Do you drink alcohol?"
         },
         {
          "type": "text",
          "name": "drinks-per-week",
          "visibleIf": "{alcohol} = true",
          "title": "How many drinks per week?"
         }
        ],
        "startWithNewLine": false
       },
       {
        "type": "panel",
        "name": "drug-use-history",
        "elements": [
         {
          "type": "checkbox",
          "name": "recreational-drugs",
          "title": "Do you use recreational drugs?",
          "choices": [
           {
            "value": "rarely",
            "text": "Rarely"
           },
           {
            "value": "marijuana",
            "text": "Marijuana"
           },
           {
            "value": "cocaine",
            "text": "Cocaine"
           },
           {
            "value": "opioids",
            "text": "Opioids"
           }
          ],
          "showOtherItem": true,
          "showNoneItem": true,
          "otherPlaceholder": "Please specify... ",
          "noneText": "Never",
          "otherText": "Other",
          "colCount": 3
         },
         {
          "type": "text",
          "name": "drug-use-times-per-month",
          "visibleIf": "{recreational-drugs} anyof ['rarely', 'marijuana', 'cocaine', 'opioids', 'other']",
          "title": "How many times per month",
          "description": "If you take different types of drugs, please specify the frequency of use for each in a 'drug - # times/month' format."
         }
        ]
       },
       {
        "type": "panel",
        "name": "personal-info",
        "elements": [
         {
          "type": "dropdown",
          "name": "education",
          "title": "What is your highest level of education completed?",
          "choices": [
           {
            "value": "high-school",
            "text": "High School"
           },
           {
            "value": "trade-school",
            "text": "Trade School"
           },
           {
            "value": "college",
            "text": "College"
           },
           {
            "value": "post-graduate",
            "text": "Post-graduate degree(s)"
           }
          ]
         },
         {
          "type": "dropdown",
          "name": "marital-status",
          "title": "What is your marital status?",
          "choices": [
           {
            "value": "married",
            "text": "Married"
           },
           {
            "value": "partnership",
            "text": "Partnership"
           },
           {
            "value": "divorced",
            "text": "Divorced"
           },
           {
            "value": "separated",
            "text": "Separated"
           },
           {
            "value": "single",
            "text": "Single"
           },
           {
            "value": "widow",
            "text": "Widow(er)"
           }
          ]
         },
         {
          "type": "panel",
          "name": "sexual-life",
          "elements": [
           {
            "type": "boolean",
            "name": "sexually-active",
            "title": "Are you sexually active?"
           },
           {
            "type": "text",
            "name": "sexual-partners-number",
            "title": "How many sexual partners do you have?",
            "inputType": "number",
            "min": 0
           },
           {
            "type": "radiogroup",
            "name": "sexual-partners-gender",
            "titleLocation": "hidden",
            "choices": [
             {
              "value": "men",
              "text": "Men"
             },
             {
              "value": "women",
              "text": "Women"
             },
             {
              "value": "both",
              "text": "Both"
             }
            ],
            "colCount": 3
           },
           {
            "type": "radiogroup",
            "name": "contraception",
            "title": "Do you use contraception?",
            "showCommentArea": true,
            "commentText": "If yes, what method?",
            "choices": [
             {
              "value": "yes",
              "text": "Yes"
             },
             {
              "value": "no",
              "text": "No"
             }
            ]
           }
          ]
         }
        ]
       },
       {
        "type": "panel",
        "name": "employment-exercises-children",
        "elements": [
         {
          "type": "radiogroup",
          "name": "employment",
          "title": "Are you employed?",
          "showCommentArea": true,
          "commentText": "Type of work",
          "choices": [
           {
            "value": "yes",
            "text": "Yes"
           },
           {
            "value": "no",
            "text": "No"
           },
           {
            "value": "retired",
            "text": "Retired"
           }
          ],
          "colCount": 3
         },
         {
          "type": "panel",
          "name": "physical-activity",
          "elements": [
           {
            "type": "radiogroup",
            "name": "do-exercise",
            "title": "Do you exercise?",
            "choices": [
             {
              "value": "yes",
              "text": "Yes"
             },
             {
              "value": "no",
              "text": "No"
             }
            ],
            "colCount": 2
           },
           {
            "type": "multipletext",
            "name": "activities",
            "visibleIf": "{do-exercise} = 'yes'",
            "titleLocation": "hidden",
            "items": [
             {
              "name": "activity-type",
              "title": "Type of activity"
             },
             {
              "name": "activity-frequency",
              "title": "How often"
             },
             {
              "name": "activity-duration",
              "title": "How long per activity"
             }
            ]
           }
          ]
         },
         {
          "type": "panel",
          "name": "children",
          "elements": [
           {
            "type": "boolean",
            "name": "have-children",
            "title": "Do you have children?"
           },
           {
            "type": "multipletext",
            "name": "children-ages",
            "visibleIf": "{have-children} = true",
            "titleLocation": "hidden",
            "items": [
             {
              "name": "children-number",
              "title": "# of children"
             },
             {
              "name": "ages",
              "title": "Their ages"
             }
            ]
           }
          ]
         }
        ],
        "startWithNewLine": false
       }
      ]
     }
    ],
    "title": "Social history"
   },
   {
    "name": "Surgical history / recent hospitalizations",
    "elements": [
     {
      "type": "comment",
      "name": "surgery-description",
      "title": "Date and type of surgery / procedure"
     }
    ],
    "title": "Surgical history / recent hospitalizations"
   },
   {
    "name": "Family history",
    "elements": [
     {
      "type": "matrixdynamic",
      "name": "family-history",
      "titleLocation": "hidden",
      "columns": [
       {
        "name": "relation",
        "title": "Relation"
       },
       {
        "name": "health-conditions",
        "title": "Health conditions"
       },
       {
        "name": "cancer-history",
        "title": "Family history of cancer"
       }
      ],
      "cellType": "text"
     }
    ],
    "title": "Family history"
   },
   {
    "name": "Preventive care",
    "elements": [
     {
      "type": "panel",
      "name": "preventive-care",
      "elements": [
       {
        "type": "panel",
        "name": "recent-shots-panel",
        "elements": [
         {
          "type": "matrixdropdown",
          "name": "recent-shots",
          "title": "Recent shots from a doctor or pharmacist",
          "columns": [
           {
            "name": "date",
            "title": "Date"
           },
           {
            "name": "place",
            "title": "Place"
           }
          ],
          "cellType": "text",
          "rows": [
           {
            "value": "flu",
            "text": "Flu"
           },
           {
            "value": "shingles",
            "text": "Shingles"
           },
           {
            "value": "pneumonia",
            "text": "Pneumonia"
           },
           {
            "value": "tetanus",
            "text": "Tetanus"
           },
           {
            "value": "other",
            "text": "Other"
           }
          ]
         }
        ]
       },
       {
        "type": "panel",
        "name": "recent-tests-panel",
        "elements": [
         {
          "type": "matrixdropdown",
          "name": "recent-tests",
          "title": "Recent tests or procedures",
          "columns": [
           {
            "name": "date",
            "title": "Date"
           },
           {
            "name": "place",
            "title": "Place"
           }
          ],
          "cellType": "text",
          "rows": [
           {
            "value": "colonoscopy",
            "text": "Colonoscopy"
           },
           {
            "value": "cologuard",
            "text": "Cologuard"
           },
           {
            "value": "mammogram",
            "text": "Mammogram"
           },
           {
            "value": "pap",
            "text": "PAP"
           },
           {
            "value": "other",
            "text": "Other"
           }
          ]
         }
        ],
        "startWithNewLine": false
       },
       {
        "type": "panel",
        "name": "specialists-panel",
        "elements": [
         {
          "type": "matrixdynamic",
          "name": "specialists",
          "title": "Specialists",
          "columns": [
           {
            "name": "provider",
            "title": "Provider's first and last name"
           },
           {
            "name": "speciality",
            "title": "Speciality"
           },
           {
            "name": "city",
            "title": "Town/City"
           }
          ],
          "cellType": "text",
          "rowCount": 1
         }
        ]
       },
       {
        "type": "panel",
        "name": "medications-and-allergies",
        "elements": [
         {
          "type": "multipletext",
          "name": "medications",
          "title": "Medications",
          "items": [
           {
            "name": "medication-name",
            "title": "Name"
           },
           {
            "name": "medication-dose",
            "title": "Dose"
           },
           {
            "name": "medication-times-per-day",
            "title": "Times per day"
           }
          ]
         },
         {
          "type": "multipletext",
          "name": "allergies",
          "startWithNewLine": false,
          "title": "Allergies",
          "items": [
           {
            "name": "allergy-type",
            "title": "Type"
           },
           {
            "name": "allergy-reaction",
            "title": "Reaction"
           }
          ]
         }
        ]
       }
      ]
     }
    ],
    "title": "Preventive care"
   },
   {
    "name": "Symptoms",
    "elements": [
     {
      "type": "tagbox",
      "name": "symptoms",
      "title": "Please select any symptoms you have now or have had in the past month.",
      "choices": [
       "Fever",
       "Chills",
       "Feeling poorly",
       "Feeling tired",
       "Weight gain",
       "Weight loss",
       "Chest pain",
       "Heart pounding",
       "Fast pulse",
       "Slow pulse",
       "Leg pain with exercise",
       "Leg swelling",
       "Joint pain",
       "Neck pain",
       "Joint swelling",
       "Joint stiffness",
       "Muscle aches",
       "Back pain",
       "Sores",
       "Rash",
       "Itching",
       "Change in a mole",
       "Unusual growth/spot"
      ]
     },
     {
      "type": "signaturepad",
      "name": "signature",
      "title": "Signature:",
      "titleLocation": "left"
     },
     {
      "type": "text",
      "name": "current-date",
      "startWithNewLine": false,
      "title": "Today's date:",
      "titleLocation": "left",
      "defaultValueExpression": "today()",
      "inputType": "date"
     }
    ],
    "title": "Symptoms"
   }
  ]
 };
```

### `src/app/components/survey.component.css`

```css
.navigation-block {
    display: flex;
    padding: 24px;
    align-items: center;
    gap: 16px;
    justify-content: space-between;
    background-color: #fff;
}

.navigation-page-selector {
    box-sizing: border-box;
    width: 100%;
    flex-basis: 240px;
    cursor: pointer;
    background-color: var(--sjs2-color-component-formbox-default-bg, #f5f5f5);
    border: none;
    border-radius: var(--sjs2-radius-component-formbox, 8px);
    box-shadow: var(
        --sjs2-border-effect-component-formbox-default,
        0 1px 2px 0 #d4d4d4 inset
    );
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
    font-family: var(--sjs2-typography-font-family-component-input-content, inherit);
    font-size: var(--sjs2-typography-font-size-component-input-content, 16px);
    font-weight: var(--sjs2-typography-font-weight-component-input-content, 400);
    line-height: var(--sjs2-typography-line-height-component-input-content, 24px);
    color: var(--sjs2-color-component-input-default-value, #1c1b20);
    min-height: calc(
        var(--sjs2-typography-line-height-component-input-content, 24px) +
            var(--sjs2-spacing-x100, 8px) * 2 +
            var(--sjs2-spacing-x050, 4px) * 2
    );
    padding:
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x100, 8px))
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x150, 12px) + 1.25em)
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x100, 8px))
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x150, 12px));
    background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 10 10'%3E%3Cpolygon fill='%23404040' points='2,2 0,4 5,9 10,4 8,2 5,5'/%3E%3C/svg%3E");
    background-repeat: no-repeat;
    background-position: right calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x150, 12px)) center;
    background-size: 0.57em auto;
}

.navigation-page-selector:focus {
    outline: none;
    background-color: var(--sjs2-color-component-formbox-focused-bg, #f5f5f5);
    box-shadow:
        var(--sjs2-border-effect-component-formbox-default-reset, 0 0 0 0 #d4d4d4 inset),
        var(--sjs2-border-effect-component-formbox-focused, 0 0 0 2px #19b394 inset);
}
.navigation-progress-container {
    display: flex;
    flex-direction: column;
    align-items: end;
}
.navigation-buttons-container {
    display: flex;
    gap: 8px;
}
.navigation-button {
    line-height: 24px;
    font-weight: 600;
    font-family: 'Open Sans';
    font-style: normal;

    font-size: 16px;
    padding: 12px 32px;
    border-color: #000000;
    border-radius: 4px;    
    background-color: #FFFFFF;
    color: #000;
    cursor: pointer;
    outline: none;
}
.navigation-text-container {
    line-height: 24px;
    font-family: 'Open Sans';    
    padding: 12px 24px;
    color: #000;
    cursor: pointer;
    outline: none;
}
.navigation-text {
    right: 0;
    top: 8px;
    font-family: 'Open Sans';
    font-style: normal;
    font-weight: 400;
    font-size: 12px;
    line-height: 16px;
    color: #000;
    text-align: right;            
}
```

### `src/app/components/survey.component.html`

```html
<div>
  <div *ngIf="!model.isCompleted" class="navigation-block">
    <select
      #pageSelector
      class="navigation-page-selector"
      [value]="model.currentPageNo"
      (change)="jumpToPage($event)"
      aria-label="Select survey page"
    >
      <option
        *ngFor="let page of model.visiblePages; let i = index"
        [value]="i"
      >
        Page {{i + 1}}
      </option>
    </select>
    <div class="navigation-progress-container">
        <div class="navigation-buttons-container">
            <div class="navigation-text-container">
                <span class="navigation-text">
                    Page {{model.currentPageNo + 1}} of {{model.visiblePages.length}}
                </span>
            </div>
            <button *ngIf="!model.isFirstPage"
                    (click)="model.prevPage()">
                Previous Page
            </button>
            <button *ngIf="!model.isLastPage"
                    (click)="model.nextPage()">
                Next Page
            </button>
            <button *ngIf="model.isLastPage"
                    (click)="model.tryComplete()">
                Complete
            </button>
        </div>      
    </div>
  </div>
  <survey [model]="model"></survey>
</div>
  
```

### `src/app/components/survey.component.ts`

```ts
import { Component, OnInit } from "@angular/core";
import { Model } from "survey-core";
import { json } from "./json";
import "./survey.component.css";
import "survey-core/survey-core.min.css";

@Component({
    // tslint:disable-next-line:component-selector
    selector: "component-survey",
    templateUrl: "./survey.component.html",
    styleUrls: ["./survey.component.css"]
})
export class SurveyComponent implements OnInit {
    jumpToPage(event: Event) {
        const input = event.target as HTMLInputElement;
        if (this.model.currentPage.validate()) {
            this.model.currentPageNo = JSON.parse(input.value);
        } else {
            input.value = this.model.currentPageNo.toString();
        }
    }
    model: Model;
    ngOnInit() {
        const survey = new Model(json);
        survey.onComplete.add((sender, options) => {
            console.log(JSON.stringify(sender.data, null, 3));
        });
        this.model = survey;
    }
}
```

### `src/app/app.component.css`

```css

```

### `src/app/app.component.html`

```html
<component-survey></component-survey>
```

### `src/app/app.component.ts`

```ts
import { Component } from "@angular/core";

@Component({
    selector: "app-root",
    templateUrl: "./app.component.html",
    styleUrls: ["./app.component.css"]
})
export class AppComponent {
    title = "CodeSandbox";
}
```

### `src/app/app.module.ts`

```ts
import { BrowserModule } from "@angular/platform-browser";
import { NgModule } from "@angular/core";

import { AppComponent } from "./app.component";
import { SurveyModule } from "survey-angular-ui";
import { SurveyComponent } from "./components/survey.component";

@NgModule({
    declarations: [AppComponent, SurveyComponent],
    imports: [BrowserModule, SurveyModule],
    providers: [],
    bootstrap: [AppComponent]
})
export class AppModule { }
```

### `src/environments/environment.prod.ts`

```ts
export const environment = {
    production: true
};
```

### `src/environments/environment.ts`

```ts
// The file contents for the current environment will overwrite these during build.
// The build system defaults to the dev environment which uses `environment.ts`, but if you do
// `ng build --env=prod` then `environment.prod.ts` will be used instead.
// The list of which env maps to which file can be found in `.angular-cli.json`.

export const environment = {
    production: false
};
```

### `src/index.html`

```html
<app-root></app-root>
```

### `src/main.ts`

```ts
import { enableProdMode } from "@angular/core";
import { platformBrowserDynamic } from "@angular/platform-browser-dynamic";

import { AppModule } from "./app/app.module";
import { environment } from "./environments/environment";

if (environment.production) {
    enableProdMode();
}

platformBrowserDynamic()
    .bootstrapModule(AppModule)
    .catch(err => console.log(err));
```

### `src/polyfills.ts`

```ts
/**
 * This file includes polyfills needed by Angular and is loaded before the app.
 * You can add your own extra polyfills to this file.
 *
 * This file is divided into 2 sections:
 *   1. Browser polyfills. These are applied before loading ZoneJS and are sorted by browsers.
 *   2. Application imports. Files imported after ZoneJS that should be loaded before your main
 *      file.
 *
 * The current setup is for so-called "evergreen" browsers; the last versions of browsers that
 * automatically update themselves. This includes Safari >= 10, Chrome >= 55 (including Opera),
 * Edge >= 13 on the desktop, and iOS 10 and Chrome on mobile.
 *
 * Learn more in https://angular.io/docs/ts/latest/guide/browser-support.html
 */

/***************************************************************************************************
 * BROWSER POLYFILLS
 */

/** IE9, IE10 and IE11 requires all of the following polyfills. **/
// import 'core-js/es6/symbol';
// import 'core-js/es6/object';
// import 'core-js/es6/function';
// import 'core-js/es6/parse-int';
// import 'core-js/es6/parse-float';
// import 'core-js/es6/number';
// import 'core-js/es6/math';
// import 'core-js/es6/string';
// import 'core-js/es6/date';
// import 'core-js/es6/array';
// import 'core-js/es6/regexp';
// import 'core-js/es6/map';
// import 'core-js/es6/weak-map';
// import 'core-js/es6/set';

/** IE10 and IE11 requires the following for NgClass support on SVG elements */
// import 'classlist.js';  // Run `npm install classlist.js`.

/** IE10 and IE11 requires the following for the Reflect API. */
// import 'core-js/es6/reflect';

/** Evergreen browsers require these. **/
// Used for reflect-metadata in JIT. If you use AOT (and only Angular decorators), you can remove.
import "core-js/proposals/reflect-metadata";

/**
 * Required to support Web Animations `@angular/platform-browser/animations`.
 * Needed for: All but Chrome, Firefox and Opera. http://caniuse.com/#feat=web-animation
 **/
// import 'web-animations-js';  // Run `npm install web-animations-js`.

/***************************************************************************************************
 * Zone JS is required by default for Angular itself.
 */
import "zone.js/dist/zone"; // Included with Angular CLI.

/***************************************************************************************************
 * APPLICATION IMPORTS
 */
```

### `src/styles.css`

```css
.navigation-block {
    display: flex;
    padding: 24px;
    align-items: center;
    gap: 16px;
    justify-content: space-between;
    background-color: #fff;
}

.navigation-page-selector {
    box-sizing: border-box;
    width: 100%;
    flex-basis: 240px;
    cursor: pointer;
    background-color: var(--sjs2-color-component-formbox-default-bg, #f5f5f5);
    border: none;
    border-radius: var(--sjs2-radius-component-formbox, 8px);
    box-shadow: var(
        --sjs2-border-effect-component-formbox-default,
        0 1px 2px 0 #d4d4d4 inset
    );
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
    font-family: var(--sjs2-typography-font-family-component-input-content, inherit);
    font-size: var(--sjs2-typography-font-size-component-input-content, 16px);
    font-weight: var(--sjs2-typography-font-weight-component-input-content, 400);
    line-height: var(--sjs2-typography-line-height-component-input-content, 24px);
    color: var(--sjs2-color-component-input-default-value, #1c1b20);
    min-height: calc(
        var(--sjs2-typography-line-height-component-input-content, 24px) +
            var(--sjs2-spacing-x100, 8px) * 2 +
            var(--sjs2-spacing-x050, 4px) * 2
    );
    padding:
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x100, 8px))
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x150, 12px) + 1.25em)
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x100, 8px))
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x150, 12px));
    background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 10 10'%3E%3Cpolygon fill='%23404040' points='2,2 0,4 5,9 10,4 8,2 5,5'/%3E%3C/svg%3E");
    background-repeat: no-repeat;
    background-position: right calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x150, 12px)) center;
    background-size: 0.57em auto;
}

.navigation-page-selector:focus {
    outline: none;
    background-color: var(--sjs2-color-component-formbox-focused-bg, #f5f5f5);
    box-shadow:
        var(--sjs2-border-effect-component-formbox-default-reset, 0 0 0 0 #d4d4d4 inset),
        var(--sjs2-border-effect-component-formbox-focused, 0 0 0 2px #19b394 inset);
}
.navigation-progress-container {
    display: flex;
    flex-direction: column;
    align-items: end;
}
.navigation-buttons-container {
    display: flex;
    gap: 8px;
}
.navigation-button {
    line-height: 24px;
    font-weight: 600;
    font-family: 'Open Sans';
    font-style: normal;

    font-size: 16px;
    padding: 12px 32px;
    border-color: #000000;
    border-radius: 4px;    
    background-color: #FFFFFF;
    color: #000;
    cursor: pointer;
    outline: none;
}
.navigation-text-container {
    line-height: 24px;
    font-family: 'Open Sans';    
    padding: 12px 24px;
    color: #000;
    cursor: pointer;
    outline: none;
}
.navigation-text {
    right: 0;
    top: 8px;
    font-family: 'Open Sans';
    font-style: normal;
    font-weight: 400;
    font-size: 12px;
    line-height: 16px;
    color: #000;
    text-align: right;            
}
```

### `src/typings.d.ts`

```ts
/* SystemJS module definition */
declare var module: NodeModule;
interface NodeModule {
    id: string;
}
```

### `.angular-cli.json`

```json
{
  "apps": [
    {
      "root": "src",
      "outDir": "dist",
      "assets": [ "assets", "favicon.ico" ],
      "index": "index.html",
      "main": "main.ts",
      "polyfills": "polyfills.ts",
      "prefix": "app",
      "styles": [ "styles.css" ],
      "scripts": [ ],
      "environmentSource": "environments/environment.ts",
      "environments": {
        "dev": "environments/environment.ts",
        "prod": "environments/environment.prod.ts"
      }
    }
  ]
}
```

### `_tsconfig.json`

```json
{
  "compileOnSave": false,
  "compilerOptions": {
    "baseUrl": "./",
    "outDir": "./dist/out-tsc",
    "sourceMap": true,
    "declaration": false,
    "allowSyntheticDefaultImports": true,
    "downlevelIteration": true,
    "experimentalDecorators": true,
    "moduleResolution": "node",
    "importHelpers": true,
    "resolveJsonModule": true,
    "target": "es2015",
    "module": "es2020",
    "lib": [
      "es2018",
      "dom"
    ]
  }
}
```

### `package.json`

```json
{
  "name": "surveyjs-angular",
  "scripts": {
    "ng": "ng",
    "start": "ng serve",
    "build": "ng build --prod",
    "test": "ng test",
    "lint": "ng lint",
    "e2e": "ng e2e"
  },
  "private": true,
  "dependencies": {
    "@angular/animations": "14.1.1",
    "@angular/cdk": "14.1.1",
    "@angular/common": "14.1.1",
    "@angular/compiler": "14.1.1",
    "@angular/core": "14.1.1",
    "@angular/forms": "14.1.1",
    "@angular/platform-browser": "14.1.1",
    "@angular/platform-browser-dynamic": "14.1.1",
    "@angular/router": "14.1.1",
    "core-js": "3.6.4",
    "rxjs": "6.5.4",
    "survey-core": "latest",
    "survey-angular-ui": "latest",
    "tslib": "1.13.0",
    "zone.js": "0.11.7"
  },
  "devDependencies": {
    "@angular/cli": "1.6.6",
    "@angular/compiler-cli": "^5.2.0",
    "@angular/language-service": "^5.2.0",
    "@types/core-js": "0.9.46",
    "@types/jasmine": "~2.8.3",
    "@types/jasminewd2": "~2.0.2",
    "@types/node": "~6.0.60",
    "codelyzer": "^4.0.1",
    "jasmine-core": "~2.8.0",
    "jasmine-spec-reporter": "~4.2.1",
    "karma": "~2.0.0",
    "karma-chrome-launcher": "~2.2.0",
    "karma-coverage-istanbul-reporter": "^1.2.1",
    "karma-jasmine": "~1.1.0",
    "karma-jasmine-html-reporter": "^0.2.2",
    "protractor": "~5.1.2",
    "ts-node": "~4.1.0",
    "tslint": "~5.9.1",
    "typescript": "3.9.7"
  },
  "keywords": [ "angular", "surveyjs" ],
  "description": "SurveyJS-Angular example project"
}
```

## Other Frameworks

- [React](https://surveyjs.io/form-library/examples/external-form-navigation-system/reactjs.md)
- [Vue 3](https://surveyjs.io/form-library/examples/external-form-navigation-system/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/external-form-navigation-system/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/external-form-navigation-system/vanillajs.md)


---
title: Implement External Form Navigation
product: Form Library
description: Learn how to enhance your form navigation with external controls that dynamically update the form page number in real-time. Implement external buttons for seamless form progression. Unlock the power of controlling your form from outside the form widget and create a streamlined user experience. Free demo for JavaScript.
framework: React
source: https://surveyjs.io/form-library/examples/external-form-navigation-system/reactjs
index: https://surveyjs.io/form-library/examples/overview.md
---

# Implement External Form Navigation (React)

SurveyJS ships with multiple navigation features that you can add to your forms: navigation buttons, a [table of contents](https://surveyjs.io/form-library/examples/table-of-contents/), and various types of [progress indicators](https://surveyjs.io/form-library/examples/configure-form-navigation-with-progress-indicators/). You can also implement custom navigation elements that extend the built-in functionality or completely replace it. This demo shows how to implement external form navigation controls&mdash;a page selector, navigation buttons, and a progress indicator&mdash;and use them in conjunction with built-in form navigation features.

## Configure a Page Selector

A page selector is a UI element that displays a list of survey pages and enables users to jump to a selected page. Usually, a page selector is a drop-down menu. If your survey contains a few pages only, a page selector can be a set of buttons with page numbers.

This example demonstrates a drop-down page selector built upon a standard `<select>` HTML element. To fill `<select>` options, iterate over `SurveyModel`'s [`visiblePages`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#visiblePages) array and create an `<option>` element for each array item. Within the `<select>` element's `onchange` event handler, call the current page's [`validate()`](https://surveyjs.io/form-library/documentation/api-reference/page-model#validate) method to perform validation. If all answers on the current page are valid, assign the selected page number to `SurveyModel`'s [`currentPageNo`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#currentPageNo) property. Note that this property starts to enumerate survey pages with 0.

## Implement Navigation Buttons

Built-in survey navigation buttons include Start, Next Page, Previous Page, Preview, and Complete. Depending on your use case, you may need to implement all the buttons or only a part of them. This demo implements the Next Page, Previous Page, and Complete buttons.

Add `<button>` elements to your page. To navigate between survey pages, call `SurveyModel`'s [`nextPage()`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#nextPage) and [`prevPage()`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#prevPage) methods within `<button>`'s `onclick` event handler. To end the survey, call the [`tryComplete()`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#tryComplete) method.

Navigation button visibility may depend on the current page. For example, the Previous Page button should not be visible on the first survey page, or the Complete button should appear only when a user has reached the last page. To control button visibility, use `SurveyModel`'s [`isFirstPage`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#isFirstPage) and [`isLastPage`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#isLastPage) properties or compare the `currentPageNo` property value with the length of the [`visiblePages`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#visiblePages) array.

If you implement custom navigation buttons, you may want to hide the built-in buttons to avoid functionality duplication. To do this, disable the [`showNavigationButtons`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#showNavigationButtons) property. This demo, however, keeps the built-in buttons visible to show how they can work alongside custom buttons.

## Add a Progress Indicator

A progress indicator helps users understand how far along the survey they have advanced. Progress indicators can show the number of completed survey pages, answered questions, or other progress information. In this demo, a progress indicator displays the current page number and the total number of survey pages. Use `SurveyModel`'s [`currentPageNo`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#currentPageNo) property and the length of the [`visiblePages`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#visiblePages) array to implement this progress indicator. Note that `currentPageNo` starts to enumerate survey pages with 0. Therefore, you need to add 1 to its value to get the actual current page number.

## Handle Navigation Events

A survey raises the following events that may be useful when you implement an external navigation system:

- [`onStarted`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onStarted)\
Raised when the survey starts.
- [`onCurrentPageChanged`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onCurrentPageChanged)\
Raised after the current page is switched.
- [`onComplete`](https://surveyjs.io/form-library/documentation/api-reference/survey-data-model#onComplete)\
Raised after the survey is completed.

## Files

### `public/index.html`

```html
<div id="surveyElement" style="position: absolute; top: 0; left: 0; right: 0; bottom: 0; min-height: 100%; height:100%"></div>
```

### `src/SurveyComponent.jsx`

```js
import React from "react";
import { Model } from "survey-core";
import { Survey } from "survey-react-ui";
import "survey-core/survey-core.min.css";
import "./index.css";
import { json } from "./json";

function SurveyComponent() {
    const survey = React.useMemo(() => new Model(json), []);
    const [pageNo, setPageNo] = React.useState(survey.currentPageNo);
    const [isRunning, setIsRunning] = React.useState(!survey.isCompleted);

    const syncState = React.useCallback(() => {
        setIsRunning(!survey.isCompleted);
        setPageNo(survey.currentPageNo);
    }, [survey]);

    React.useEffect(() => {
        survey.onCurrentPageChanged.add(syncState);
        survey.onComplete.add(syncState);
        syncState();

        return () => {
            survey.onCurrentPageChanged.remove(syncState);
            survey.onComplete.remove(syncState);
        };
    }, [survey, syncState]);
    survey.onComplete.add((sender, options) => {
        console.log(JSON.stringify(sender.data, null, 3));
    });
    const prevPage = () => { survey.prevPage(); };
    const nextPage = () => { survey.nextPage(); };
    const endSurvey = () => { survey.tryComplete(); };
    const jumpToPage = (pageNo) => {
        if (survey.currentPage.validate()) {
            setPageNo(pageNo);
        }
    };
    
    const getPageSelectorOptions = () => {
        const content = [];
        for (let i = 0; i < survey.visiblePages.length; i++) {
            content.push(
                <option key={i} value={i}>
                    Page {i + 1}
                </option>
            )
        }
        return content;
    };
    const PageSelector = (
        <select
            className="navigation-page-selector"
            value={pageNo}
            onChange={(evt) => { jumpToPage(JSON.parse(evt.target.value)); }}
            aria-label="Select survey page">
            {getPageSelectorOptions()}
        </select>
    );
    const renderButton = (text, func, canRender) => {
        if (!canRender) return undefined;
        return (
            <button className="navigation-button" onClick={func}>
                {text}
            </button>
        );
    };
    const renderExternalNavigation = () => {
        if (!isRunning) return undefined;
        const progressText = "Page " + (pageNo + 1) + " of " + survey.visiblePages.length;
        const progressSpan = <span className="navigation-text">{progressText}</span>;
        return (
            <div className="navigation-block">
                {PageSelector}
                <div className="navigation-progress-container">
                    <div className="navigation-buttons-container">
                        <div className="navigation-text-container">
                            {progressSpan}
                        </div>
                        {renderButton('Previous Page', prevPage, pageNo !== 0)}
                        {renderButton('Next Page', nextPage, pageNo !== survey.visiblePages.length - 1)}
                        {renderButton('Complete', endSurvey, pageNo === survey.visiblePages.length - 1)}
                    </div>                    
                </div>
            </div>
        );
    };

    return (
        <div>
            {renderExternalNavigation()}
            <Survey
                currentPageNo={pageNo}
                model={survey}
            />
        </div>
    );
}

export default SurveyComponent;
```

### `src/index.css`

```css
.navigation-block {
    display: flex;
    padding: 24px;
    align-items: center;
    gap: 16px;
    justify-content: space-between;
    background-color: #fff;
}

.navigation-page-selector {
    box-sizing: border-box;
    width: 100%;
    flex-basis: 240px;
    cursor: pointer;
    background-color: var(--sjs2-color-component-formbox-default-bg, #f5f5f5);
    border: none;
    border-radius: var(--sjs2-radius-component-formbox, 8px);
    box-shadow: var(
        --sjs2-border-effect-component-formbox-default,
        0 1px 2px 0 #d4d4d4 inset
    );
    -webkit-appearance: none;
    -moz-appearance: none;
    appearance: none;
    font-family: var(--sjs2-typography-font-family-component-input-content, inherit);
    font-size: var(--sjs2-typography-font-size-component-input-content, 16px);
    font-weight: var(--sjs2-typography-font-weight-component-input-content, 400);
    line-height: var(--sjs2-typography-line-height-component-input-content, 24px);
    color: var(--sjs2-color-component-input-default-value, #1c1b20);
    min-height: calc(
        var(--sjs2-typography-line-height-component-input-content, 24px) +
            var(--sjs2-spacing-x100, 8px) * 2 +
            var(--sjs2-spacing-x050, 4px) * 2
    );
    padding:
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x100, 8px))
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x150, 12px) + 1.25em)
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x100, 8px))
        calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x150, 12px));
    background-image: url("data:image/svg+xml,%3Csvg xmlns='http://www.w3.org/2000/svg' viewBox='0 0 10 10'%3E%3Cpolygon fill='%23404040' points='2,2 0,4 5,9 10,4 8,2 5,5'/%3E%3C/svg%3E");
    background-repeat: no-repeat;
    background-position: right calc(var(--sjs2-spacing-x050, 4px) + var(--sjs2-spacing-x150, 12px)) center;
    background-size: 0.57em auto;
}

.navigation-page-selector:focus {
    outline: none;
    background-color: var(--sjs2-color-component-formbox-focused-bg, #f5f5f5);
    box-shadow:
        var(--sjs2-border-effect-component-formbox-default-reset, 0 0 0 0 #d4d4d4 inset),
        var(--sjs2-border-effect-component-formbox-focused, 0 0 0 2px #19b394 inset);
}
.navigation-progress-container {
    display: flex;
    flex-direction: column;
    align-items: end;
}
.navigation-buttons-container {
    display: flex;
    gap: 8px;
}
.navigation-button {
    line-height: 24px;
    font-weight: 600;
    font-family: 'Open Sans';
    font-style: normal;

    font-size: 16px;
    padding: 12px 32px;
    border-color: #000000;
    border-radius: 4px;    
    background-color: #FFFFFF;
    color: #000;
    cursor: pointer;
    outline: none;
}
.navigation-text-container {
    line-height: 24px;
    font-family: 'Open Sans';    
    padding: 12px 24px;
    color: #000;
    cursor: pointer;
    outline: none;
}
.navigation-text {
    right: 0;
    top: 8px;
    font-family: 'Open Sans';
    font-style: normal;
    font-weight: 400;
    font-size: 12px;
    line-height: 16px;
    color: #000;
    text-align: right;            
}
```

### `src/index.js`

```js
import React from "react";
import { createRoot } from "react-dom/client";
import SurveyComponent from "./SurveyComponent";

const root = createRoot(document.getElementById("surveyElement"));
root.render(<SurveyComponent />);
```

### `src/json.js`

```js
export const json = {
  "title": "Patient Assessment Form",
  "pages": [
   {
    "name": "Patient information",
    "elements": [
     {
      "type": "panel",
      "name": "patient-information",
      "elements": [
       {
        "type": "text",
        "name": "first-name",
        "title": "First name"
       },
       {
        "type": "text",
        "name": "last-name",
        "startWithNewLine": false,
        "title": "Last name"
       },
       {
        "type": "text",
        "name": "ssn",
        "title": "Social Security number",
        "requiredErrorText": "You SSN must be a 9-digit number.",
        "validators": [
         {
          "type": "regex",
          "text": "Your SSN must be a 9-digit number",
          "regex": "^(?!0{3})(?!6{3})[0-8]\\d{2}-?(?!0{2})\\d{2}-?(?!0{4})\\d{4}$"
         }
        ],
        "maxLength": 9
       },
       {
        "type": "text",
        "name": "birthdate",
        "startWithNewLine": false,
        "title": "Date of birth",
        "inputType": "date",
        "maxValueExpression": "today()"
       },
       {
        "type": "text",
        "name": "concerns",
        "title": "List any concerns you want to talk about during your visit"
       }
      ]
     }
    ],
    "title": "Patient information"
   },
   {
    "name": "Health history",
    "elements": [
     {
      "type": "panel",
      "name": "health-history",
      "elements": [
       {
        "type": "boolean",
        "name": "diabetes",
        "startWithNewLine": false,
        "title": "Do you have diabetes?"
       },
       {
        "type": "boolean",
        "name": "high-blood-pressure",
        "startWithNewLine": false,
        "title": "High blood pressure?"
       },
       {
        "type": "boolean",
        "name": "high-cholesterol",
        "startWithNewLine": false,
        "title": "High cholesterol?"
       },
       {
        "type": "comment",
        "name": "other-health-conditions",
        "title": "Do you have other health conditions?",
        "maxLength": 300
       }
      ]
     }
    ],
    "title": "Health history"
   },
   {
    "name": "Social history",
    "elements": [
     {
      "type": "panel",
      "name": "social-history",
      "elements": [
       {
        "type": "panel",
        "name": "smoking",
        "elements": [
         {
          "type": "radiogroup",
          "name": "cigarettes",
          "title": "Do you smoke cigarettes?",
          "choices": [
           {
            "value": "never",
            "text": "Never"
           },
           {
            "value": "yes",
            "text": "Yes"
           },
           {
            "value": "quit",
            "text": "Quit"
           }
          ]
         },
         {
          "type": "text",
          "name": "packs-a-day",
          "visibleIf": "{cigarettes} = 'yes'",
          "title": "How many packs a day?",
          "inputType": "number",
          "min": 0
         },
         {
          "type": "panel",
          "name": "smoking-history",
          "elements": [
           {
            "type": "text",
            "name": "date-quit",
            "title": "Date quit",
            "titleLocation": "left",
            "inputType": "date",
            "maxValueExpression": "today()"
           },
           {
            "type": "text",
            "name": "years-smoked",
            "title": "Years smoked",
            "titleLocation": "left",
            "inputType": "number",
            "min": 0
           }
          ],
          "visibleIf": "{cigarettes} = 'quit'"
         },
         {
          "type": "boolean",
          "name": "vape",
          "title": "Do you vape (e-cigarettes)?"
         }
        ]
       },
       {
        "type": "panel",
        "name": "alcohol-use-history",
        "elements": [
         {
          "type": "boolean",
          "name": "alcohol",
          "title": "Do you drink alcohol?"
         },
         {
          "type": "text",
          "name": "drinks-per-week",
          "visibleIf": "{alcohol} = true",
          "title": "How many drinks per week?"
         }
        ],
        "startWithNewLine": false
       },
       {
        "type": "panel",
        "name": "drug-use-history",
        "elements": [
         {
          "type": "checkbox",
          "name": "recreational-drugs",
          "title": "Do you use recreational drugs?",
          "choices": [
           {
            "value": "rarely",
            "text": "Rarely"
           },
           {
            "value": "marijuana",
            "text": "Marijuana"
           },
           {
            "value": "cocaine",
            "text": "Cocaine"
           },
           {
            "value": "opioids",
            "text": "Opioids"
           }
          ],
          "showOtherItem": true,
          "showNoneItem": true,
          "otherPlaceholder": "Please specify... ",
          "noneText": "Never",
          "otherText": "Other",
          "colCount": 3
         },
         {
          "type": "text",
          "name": "drug-use-times-per-month",
          "visibleIf": "{recreational-drugs} anyof ['rarely', 'marijuana', 'cocaine', 'opioids', 'other']",
          "title": "How many times per month",
          "description": "If you take different types of drugs, please specify the frequency of use for each in a 'drug - # times/month' format."
         }
        ]
       },
       {
        "type": "panel",
        "name": "personal-info",
        "elements": [
         {
          "type": "dropdown",
          "name": "education",
          "title": "What is your highest level of education completed?",
          "choices": [
           {
            "value": "high-school",
            "text": "High School"
           },
           {
            "value": "trade-school",
            "text": "Trade School"
           },
           {
            "value": "college",
            "text": "College"
           },
           {
            "value": "post-graduate",
            "text": "Post-graduate degree(s)"
           }
          ]
         },
         {
          "type": "dropdown",
          "name": "marital-status",
          "title": "What is your marital status?",
          "choices": [
           {
            "value": "married",
            "text": "Married"
           },
           {
            "value": "partnership",
            "text": "Partnership"
           },
           {
            "value": "divorced",
            "text": "Divorced"
           },
           {
            "value": "separated",
            "text": "Separated"
           },
           {
            "value": "single",
            "text": "Single"
           },
           {
            "value": "widow",
            "text": "Widow(er)"
           }
          ]
         },
         {
          "type": "panel",
          "name": "sexual-life",
          "elements": [
           {
            "type": "boolean",
            "name": "sexually-active",
            "title": "Are you sexually active?"
           },
           {
            "type": "text",
            "name": "sexual-partners-number",
            "title": "How many sexual partners do you have?",
            "inputType": "number",
            "min": 0
           },
           {
            "type": "radiogroup",
            "name": "sexual-partners-gender",
            "titleLocation": "hidden",
            "choices": [
             {
              "value": "men",
              "text": "Men"
             },
             {
              "value": "women",
              "text": "Women"
             },
             {
              "value": "both",
              "text": "Both"
             }
            ],
            "colCount": 3
           },
           {
            "type": "radiogroup",
            "name": "contraception",
            "title": "Do you use contraception?",
            "showCommentArea": true,
            "commentText": "If yes, what method?",
            "choices": [
             {
              "value": "yes",
              "text": "Yes"
             },
             {
              "value": "no",
              "text": "No"
             }
            ]
           }
          ]
         }
        ]
       },
       {
        "type": "panel",
        "name": "employment-exercises-children",
        "elements": [
         {
          "type": "radiogroup",
          "name": "employment",
          "title": "Are you employed?",
          "showCommentArea": true,
          "commentText": "Type of work",
          "choices": [
           {
            "value": "yes",
            "text": "Yes"
           },
           {
            "value": "no",
            "text": "No"
           },
           {
            "value": "retired",
            "text": "Retired"
           }
          ],
          "colCount": 3
         },
         {
          "type": "panel",
          "name": "physical-activity",
          "elements": [
           {
            "type": "radiogroup",
            "name": "do-exercise",
            "title": "Do you exercise?",
            "choices": [
             {
              "value": "yes",
              "text": "Yes"
             },
             {
              "value": "no",
              "text": "No"
             }
            ],
            "colCount": 2
           },
           {
            "type": "multipletext",
            "name": "activities",
            "visibleIf": "{do-exercise} = 'yes'",
            "titleLocation": "hidden",
            "items": [
             {
              "name": "activity-type",
              "title": "Type of activity"
             },
             {
              "name": "activity-frequency",
              "title": "How often"
             },
             {
              "name": "activity-duration",
              "title": "How long per activity"
             }
            ]
           }
          ]
         },
         {
          "type": "panel",
          "name": "children",
          "elements": [
           {
            "type": "boolean",
            "name": "have-children",
            "title": "Do you have children?"
           },
           {
            "type": "multipletext",
            "name": "children-ages",
            "visibleIf": "{have-children} = true",
            "titleLocation": "hidden",
            "items": [
             {
              "name": "children-number",
              "title": "# of children"
             },
             {
              "name": "ages",
              "title": "Their ages"
             }
            ]
           }
          ]
         }
        ],
        "startWithNewLine": false
       }
      ]
     }
    ],
    "title": "Social history"
   },
   {
    "name": "Surgical history / recent hospitalizations",
    "elements": [
     {
      "type": "comment",
      "name": "surgery-description",
      "title": "Date and type of surgery / procedure"
     }
    ],
    "title": "Surgical history / recent hospitalizations"
   },
   {
    "name": "Family history",
    "elements": [
     {
      "type": "matrixdynamic",
      "name": "family-history",
      "titleLocation": "hidden",
      "columns": [
       {
        "name": "relation",
        "title": "Relation"
       },
       {
        "name": "health-conditions",
        "title": "Health conditions"
       },
       {
        "name": "cancer-history",
        "title": "Family history of cancer"
       }
      ],
      "cellType": "text"
     }
    ],
    "title": "Family history"
   },
   {
    "name": "Preventive care",
    "elements": [
     {
      "type": "panel",
      "name": "preventive-care",
      "elements": [
       {
        "type": "panel",
        "name": "recent-shots-panel",
        "elements": [
         {
          "type": "matrixdropdown",
          "name": "recent-shots",
          "title": "Recent shots from a doctor or pharmacist",
          "columns": [
           {
            "name": "date",
            "title": "Date"
           },
           {
            "name": "place",
            "title": "Place"
           }
          ],
          "cellType": "text",
          "rows": [
           {
            "value": "flu",
            "text": "Flu"
           },
           {
            "value": "shingles",
            "text": "Shingles"
           },
           {
            "value": "pneumonia",
            "text": "Pneumonia"
           },
           {
            "value": "tetanus",
            "text": "Tetanus"
           },
           {
            "value": "other",
            "text": "Other"
           }
          ]
         }
        ]
       },
       {
        "type": "panel",
        "name": "recent-tests-panel",
        "elements": [
         {
          "type": "matrixdropdown",
          "name": "recent-tests",
          "title": "Recent tests or procedures",
          "columns": [
           {
            "name": "date",
            "title": "Date"
           },
           {
            "name": "place",
            "title": "Place"
           }
          ],
          "cellType": "text",
          "rows": [
           {
            "value": "colonoscopy",
            "text": "Colonoscopy"
           },
           {
            "value": "cologuard",
            "text": "Cologuard"
           },
           {
            "value": "mammogram",
            "text": "Mammogram"
           },
           {
            "value": "pap",
            "text": "PAP"
           },
           {
            "value": "other",
            "text": "Other"
           }
          ]
         }
        ],
        "startWithNewLine": false
       },
       {
        "type": "panel",
        "name": "specialists-panel",
        "elements": [
         {
          "type": "matrixdynamic",
          "name": "specialists",
          "title": "Specialists",
          "columns": [
           {
            "name": "provider",
            "title": "Provider's first and last name"
           },
           {
            "name": "speciality",
            "title": "Speciality"
           },
           {
            "name": "city",
            "title": "Town/City"
           }
          ],
          "cellType": "text",
          "rowCount": 1
         }
        ]
       },
       {
        "type": "panel",
        "name": "medications-and-allergies",
        "elements": [
         {
          "type": "multipletext",
          "name": "medications",
          "title": "Medications",
          "items": [
           {
            "name": "medication-name",
            "title": "Name"
           },
           {
            "name": "medication-dose",
            "title": "Dose"
           },
           {
            "name": "medication-times-per-day",
            "title": "Times per day"
           }
          ]
         },
         {
          "type": "multipletext",
          "name": "allergies",
          "startWithNewLine": false,
          "title": "Allergies",
          "items": [
           {
            "name": "allergy-type",
            "title": "Type"
           },
           {
            "name": "allergy-reaction",
            "title": "Reaction"
           }
          ]
         }
        ]
       }
      ]
     }
    ],
    "title": "Preventive care"
   },
   {
    "name": "Symptoms",
    "elements": [
     {
      "type": "tagbox",
      "name": "symptoms",
      "title": "Please select any symptoms you have now or have had in the past month.",
      "choices": [
       "Fever",
       "Chills",
       "Feeling poorly",
       "Feeling tired",
       "Weight gain",
       "Weight loss",
       "Chest pain",
       "Heart pounding",
       "Fast pulse",
       "Slow pulse",
       "Leg pain with exercise",
       "Leg swelling",
       "Joint pain",
       "Neck pain",
       "Joint swelling",
       "Joint stiffness",
       "Muscle aches",
       "Back pain",
       "Sores",
       "Rash",
       "Itching",
       "Change in a mole",
       "Unusual growth/spot"
      ]
     },
     {
      "type": "signaturepad",
      "name": "signature",
      "title": "Signature:",
      "titleLocation": "left"
     },
     {
      "type": "text",
      "name": "current-date",
      "startWithNewLine": false,
      "title": "Today's date:",
      "titleLocation": "left",
      "defaultValueExpression": "today()",
      "inputType": "date"
     }
    ],
    "title": "Symptoms"
   }
  ]
 };
```

### `package.json`

```json
{
  "dependencies": {
    "react": "latest",
    "react-dom": "latest",
    "babel": "latest",
    "survey-core": "latest",
    "survey-react-ui": "latest"
  },
  "devDependencies": {
    "react-scripts": "latest"
  }
}
```

## Other Frameworks

- [Angular](https://surveyjs.io/form-library/examples/external-form-navigation-system/angular.md)
- [Vue 3](https://surveyjs.io/form-library/examples/external-form-navigation-system/vue3js.md)
- [jQuery](https://surveyjs.io/form-library/examples/external-form-navigation-system/jquery.md)
- [Vanilla JS](https://surveyjs.io/form-library/examples/external-form-navigation-system/vanillajs.md)
